<?php 
/**
 * Author: Andreas Möller
 *
 * License: GNU GPL
 *
 * Description: I read CustomEdit and extended it by
 *    Parameter Type Definition
 *    Different input field types like checkboxes dropdownlists 
 *       and multiline inputfields.
 *  I removed from it the ability to show the form editor for an empty
 *           especially new article by removing the need of a special page.
 * for more details see www.mediawiki.org
 
 new features by Gero Scholz:
 
 * Parameters appearing in a template call which are not used in the template
   will be shown and marked as "WILL BE DELETED ON SAVE"
 * Parameters not appearing in a template call but being used in the template
   will be added and marked as "WILL BE ADDED ON SAVE"
 * Parameters appearing in a template call which are used in the template but not DEFINED
   will be shown using a DEFAULT DEFINITION
 * note that a parameter will be regarded as DEFINED if it appears in the template,
   even if it only appers within an HTML-COMMENT
 * note that the sequence in the edit form corresponds to the sequence
   in which parameters appear within the tenmplate (including parameters within html comnment blocks)
 * a formatting option named 'pagename' ensures that the value of a parameter with that option
   will always be set to the {{PAGENAME}} of the article
 * label and comment in typedefinition may contain wiki syntax
 
 changes which you may like or dislike
 
 * oneof - list have a minimum width
 * the separator for enumerations was chnged from comma to semicolon
 
 minor technical improvements
 
 * runs under MediaWiki 1.16
 * using is_array on non-existing variables led to errors (array_element_exists() added)
 * formatting with the option "use_newline" was enhanced (indenting, right justified field names)
 * fixed some miorn bugs (uninitialized variables etc.)

 */

if( !defined( 'MEDIAWIKI' ) ) {
  echo( "This MediaWiki extension cannot be run standalone.\n\n"
		."Die MediaWikierweiterung ist eigenständig nicht ausführbar." );
  die( -1 );
} else {
  global $wgAutoloadClasses;
  
  // initialization of the Extension
  $dir = dirname( __FILE__ ) . '/';
  
  $wgAutoloadClasses['clsTemplateEditorHooks'] =  $dir . 'TemplateForm.hooks.php';
  $wgAutoloadClasses['clsTypeDefinition']      =  $dir . 'clsTypeDefinition.php';
  $wgAutoloadClasses['clsTemplateForm']        =  $dir . 'TemplateForm.Editor.php';
  
  // Register parser hook
  $wgHooks['ParserFirstCallInit'][] = 'clsTemplateEditorHooks::register';
  $wgHooks['AlternateEdit'][] = 'clsTemplateForm::eventhandler';

}




