<?php

class clsTypeDefinition{
  
  const tagname="typedefinition";
  
  /**
   * parserevent-handler
   *
   * this function displays the type definition inside the template definition page in a table
   *
   *@param input
   *@param params
   *@param parser
   *
   */
  public static function render($input, $params, $parser) {
	global $wgParser, $wgUser;
	
	wfLoadExtensionMessages( 'TemplateFormEdit' );
	
	$lines = explode( chr(10),$input );
	$htmlLines="\n";
	
	$numberOfLines = count($lines);
	for ($No = 0; $No < $numberOfLines; $No ++){
	  $line=trim($lines[$No]);
	  if (substr($line,0,1)=="*"){
		
		$definition = self::parseLine($lines,$No);
		$parserOptions = ParserOptions::newFromUser( $wgUser );
		$htmlLines .= "<tr><td>".$definition['Name'].
		  "</td><td>".$wgParser->replaceVariables($definition['Label'])."</td><td>".$definition['Type'].
		  '</td><td width="300px">'.$wgParser->replaceVariables($definition['Params']).
		  "</td><td>".$wgParser->replaceVariables($definition['Comment']).
		  "</td><td>".$wgParser->replaceVariables($definition['Command']).
		  "</td></tr>\n";
		
	  }
	  
	}
	$htmlLines ='<table class="typedefinitiontable"><tr>'.
	  "\n     <th>".wfMsg('name').
	  "\n	  <th>".wfMsg('label').
	  "\n	  <th>".wfMsg('type').
	  "\n	  <th>".wfMsg('params').
	  "\n	  <th>".wfMsg('comment').
	  "\n	  <th>".wfMsg('command').
	  "\n	 </tr>\n".$htmlLines.'</table>';
	
	$css = 
	  ".typedefinitiontable {border-left: dotted black 1px;}\n".
	  ".typedefinitiontable td {border-right: dotted black 1px; border-bottom: solid silver 1px }\n".
	  ".typedefinitiontable th {border: dotted #000077 1px ;background-color: #9999dd}";
	
	$css = '<style type="text/css">'."\n".$css."\n</style>";
	
	 return '<nowiki>'. $css .'</nowiki>'. $htmlLines;
	 
  }
  
  /**
   * is used by createHtmlFormTag for creating a single inputfield, 
   * - is called once for each Parameter of the template
   * calls the function corresponding to the parameters type
   * for generating the inputfield's html-code
   *
   * @param parameter - an array describing a parameter
   * @param templateUsed
   */
  function createHtmlInputElement($parameter,$templateUsed){
    global $wgOut;
    $type= $parameter['type'];
    switch ($type){
    case "oneof":
      $result=$this->typeOneOf($parameter,$templateUsed,false);          
      break;
    case "oneof+":
	  // user can use a value which is not in the list
      $result=$this->typeOneOf($parameter,$templateUsed,true);          
      break;
    case "someof":
      $result=$this->typeSomeOf($parameter,$templateUsed);                
      break;
    case "text":
	  $result =  $this->typeText($parameter,$templateUsed);
	  break;
    default:
      $result =  $this->typeDefault($parameter,$templateUsed);
    }
    return $result;    
  }
  
  /**
   * is used for type "one of" to generate the values in the drop down list.
   * @param parameter - an array describing a paramter
   */
  function options(&$parameter, &$existing){
    $Value =     trim(str_replace("\n","",$parameter['value']));
	
	$values=array();
	$values[] = $Value;
  	$options=$this->prepareOptions($parameter['typeParams'],$values);

    $result="";
	$existing = false;
  
    for ($i=0 ; $i < count($options);$i++){
    
      $result .= '<option value="'.$options[$i].'" ';
     
      if ($options[$i] == $Value) {
		$result .=' selected="selected" ';
		$existing = true;
	  }
	  if ($options[$i]=='' && !$existing) {  // if there is an empty option it will be selected if there was no match so far
											// this means that an empty option must be the LAST one in sequence
		$result .=' selected="selected" ';
	  }
      $result .= '>'.$options[$i].'</option>'."\n";
    }
	  
    return $result;    
  }


  /**
   * Generates a drop down list for the "oneof"-parameter-type.
   * and offers an additional field to enter a new value
   *
   * @param parameter
   * @param templateUsed
   */
	function typeOneOf(&$parameter,$templateUsed,$add) {
		$Name = 'wp' . $templateUsed . str_replace(' ','_',$parameter['field']);
		$result = '<select id="'.$Name.'" name="'.$Name.'" style="min-width:20em;">';

		$existing = false;
		$result .= $this->options($parameter,$existing)."</select>\n";

		// in addition: offer way to enter new value
		if ($add) {
			$result .= '<br/><input id="'.$Name.'_NEW" name="'.$Name.'_NEW" size=30';
			if ($existing) $result .= ' value=""';
			else {
				$value = trim(str_replace("\n","",$parameter['value']));
				$result .= ' value="'.$value.'"';
			}
			$result .= ' />&nbsp;<small>(add)</small>';
		}
		return $result;
	}


  /**
   * Generates a list of Checkboxes for the "someof"-parameter-type.
   * If there are too many they are enclosed in a scrollable area.
   *
   * @param parameter
   * @param templateUsed
   */
  function typeSomeOf(&$parameter,$templateUsed){
    $Name = 'wp' . $templateUsed . str_replace(' ','_',$parameter['field']);
    
    $values=explode(',',$parameter['value']);

	if ((count($values) == 1) && (trim($values[0])=="")) $values=array(); // initially select no entry

    $options = $this->prepareOptions($parameter['typeParams'],$values);
    
    for($i = 0 ; $i < count($values) ; $i ++ ){
      $values[$i] = trim( $values[$i] );
    }
    $index=0;
	$result ='<input type="hidden" name="'.$Name.'" value="'.count($options).'">';
    foreach ($options as $option){
      $result .= '<input type="checkbox" id="'.$Name.'_'.$index.'" '
		.    'name="'.$Name.'_'.$index++.'" value="'.$option.'" ';
      if(in_array($option,$values)){
		$result .= ' checked="checked" ';
	  }
	  $result .= ' >'.$option.'<br>'."\n";
	}
	$result= $this->AddIFrame($result,'50%','7em',count($options));
    return $result;
  }

  /**
   * generates a multi line input field for the given parameter
   *
   * @param parameter
   * @param templateUsed
   */
  function typeText(&$parameter,$templateUsed){
    $plainName = $parameter['field'];
    $Name = 'wp' . $templateUsed . str_replace(' ','_',$plainName);
    $Value =     $parameter['value'];
    $params =$parameter['typeParams'];

    $xValue =trim(substr($params,1,strpos($params,',')-1));
    $yValue =substr($params,strpos($params,','));
    $yValue =trim(substr($yValue,1,strpos($yValue,')')-1));    
    
    return '<textarea id="'.$Name.'" name="'.$Name.'" rows="'.$yValue.'" width="7" cols="'.$xValue.'" style="font-family:arial,helvetica; overflow:scroll; display:inline ; width:'.$xValue.'em;float:left; margin-right:10px; margin-bottom:6px" >'.$Value.'</textarea>';
  }

  /**
   * generates a singleline inputfield
   *
   * @param parameter
   * @param templateUsed
   */
  function typeDefault($parameter,$templateUsed) {
	global $wgOut, $wgTitle; 
	
	$plainName = $parameter['field'];
    $Name    = 'wp' . $templateUsed . str_replace(' ','_',$plainName);
    $Value   =     $parameter['value'];
	$string  = str_replace(' ','',$parameter['typeParams']);
	$string  = substr($string,1,strlen($string)-2);
	$params  = explode(',',$string);

	$html    = '<input id="'.$Name.'" name="'.$Name.'" ';
	
	if (in_array('password',$params))
	  $html .= ' type="password" ';
	else
	  $html .= ' type="text" ';
	
	$size = strpos($string,',size=');
	if ($size) $size+= 6;
	
	if (substr($string,0,5)=="size=")  $size = 5;
	
	$size=substr($string,$size);


	$size=explode(',',$size);
	if (count($size)>0)  $size=$size[0];

	
	if (strLen($size)>0)
	  $html   .= 'size="'.$size.'" ';
	else	
	  $html   .= 'size="30" ';

	if (in_array('readonly',$params))
	  $html .= ' readonly ';

	if (in_array('pagename',$params)) $Value = $parameter['value'] = $wgTitle->getText();

	return $html . 'value="'.$Value.'" /> ';
  }

  /**
   * writes the Content into a scrollable Field
   * without using a second file for the content.
   *
   * @param Content - htmlcode to be shown in the scrollable area
   * @param width
   * @param height - of the display area
   * @param count - number of elements to be shown in the content.
   */
  function AddIFrame( $Content, $width, $height,$count){
	
	$style='border: 1px solid black; width:70%; '.
	  ' float:left; margin-right:10px; margin-bottom:6px;';
	if ($count > 8)
	  $style .= 'overflow:auto; height:100px;'; 
  
	return  '<div style="'.$style.'">'.$Content.'</div>';
 }

  /**
   * prepares the options for type "someof" and "oneof"
   * Adds the current value(s) to the list of allowed values
   * in order to allow the user to leave the Value unchanged.
   * Removes duplicates from the list of options.
   * Trims the option text.
   *
   * @param params The String representing the parameters in the definition page
   * @param values an array of the currently selected values (may be empty)
   * @returns the list of resulting Options.
   */
  function prepareOptions($params,&$values){
    
    $typeParams = explode(';',substr($params,1,strlen($params)-2));
    $options = array();
    // remove duplicates
    foreach($typeParams as $option){
      $option = trim(str_replace("\n","",$option));
	  if ($option=='') continue; // ignore empty tokens
      if (!in_array($option,$options))	$options[]=$option;
    }
    // add current values
	/*
    for($i = 0 ; $i < count($values) ; $i ++ ) {
      $values[$i] = trim(str_replace("\n","",$values[$i] ));
      if (!in_array($values[$i],$options))	$options[]=$values[$i];
    }
	*/
	$options[] = '';
    return $options;   
  }

  /**
   * Retrieves a list of fields available at a template (text surrounded
   * by {{{X}}} or {{{X| )
   * Uses only information of the template's definition page
   * "...?Title=Template:NAMEOFTEMPLATE"
   *
   * @param $template - the name of the template without namespace "Template:"
   * @return an array of arrays where each array describes the following
   *         properties of a template-parameter<ul>
   *  <li>the name, <li>default value <li> type 
   *  <li> type-parameters <li>alternative label <li>comment </ul>
   */
  function getTemplateFields( $template ) {
    global $wgOut, $wgParser, $wgUser;
 
	$templateText="";
    
	$t = Title::NewFromText("Template:".$template);
	$art = Revision::newFromTitle( $t );
	if( $art != null ) {
	  $templateText = $art->getText();
	}

    $parts = explode("{{{", $templateText);
    $params = array();
	
    $starttag = strpos($templateText,"<".self::tagname);
    
	if ($starttag){
	  foreach( $parts as $part ) {
		$param=self::parseParameter($part);
		if (array_key_exists('field',$param) && strlen($param['field'])>0 ) {
		  $exists = false;
		  for( $i = 0; ($i < count($params)) && (!$exists) ; $i++ ) 
			if ( $params[$i]['field'] == $param['field'] ) $exists = true;
		  
		  if (!$exists)  
			$params[] = $param;
		}
	  }
	  
	  $starttag= strpos($templateText,">",$starttag);
	  $endtag =strpos($templateText,"</".self::tagname.">",$starttag);
	  $lines=explode("\n",substr($templateText,$starttag,$endtag-$starttag));
	  
	  $numberOfLines=count($lines);
	  $parserOptions = ParserOptions::newFromUser( $wgUser );
	  
	  for($lineNo=0;$lineNo < $numberOfLines;$lineNo++){
		$line=trim($lines[$lineNo]);
		if (substr($line,0,1) =="*"){
		  $definition = self::parseLine($lines,$lineNo);
		  
		  for( $i = 0; $i < count($params); $i++ ) {
			$plainFieldName = $params[$i]['field'];
			if ($plainFieldName == $definition['Name']){
			  $params[$i]['command'] = $definition['Command'];
			  $params[$i]['type'] = $definition['Type'];
			  $params[$i]['typeParams'] = $wgParser->preprocess($definition['Params'], clsTemplateForm::getTemplateForm()->mTitle, $parserOptions);
			  $params[$i]['label'] = $wgParser->preprocess($definition['Label'], clsTemplateForm::getTemplateForm()->mTitle, $parserOptions);
			  //$params[$i]['label'] = $definition['Label'];
			  // $params[$i]['comment'] = $definition['Comment'];
			  $params[$i]['comment'] = $wgParser->preprocess($definition['Comment'], clsTemplateForm::getTemplateForm()->mTitle, $parserOptions);
			}
		  }
		}
	  }
	  
	  $params['Name']=$template;
	}
	// print_r($params);  
    return $params;
  }

  /** 
   * parses the parameter which beginns at the begin of the given text.
   * the method assumes that the leading "{{{" cut off the input string.
   *
   * @param part a string whose prefix defins one of the parameters of a template
   *
   * @returns an array with two elements='field' and 'default'
   */
  static function parseParameter($part){
	$param=array();
	$endOfBrackets = strpos($part, "}}}");
	$default=""; // (perhaps) the next if defines the default 
    if( ($positionOfPipe = strpos($part, "|")) &&
		($positionOfPipe < $endOfBrackets) ) {
	  $default=substr($part,$positionOfPipe+1,
					  $endOfBrackets - $positionOfPipe -1);
	  $endOfBrackets = $positionOfPipe;
	}
	if( $endOfBrackets ) {
	  
	  $param['field'] = trim(substr($part, 0, $endOfBrackets));
	  $param['default']=$default;
	}
	return $param;
  }  

  /**
   * Parses one line. if the Parameters are longer than one line it can
   * also parse more lines,
   *
   * parses the type definition line for a template parameter.
   */
  static function parseLine($lines,&$lineNo){
    $line=trim($lines[$lineNo]);       
    $definition['Name']="";
    $definition['Type'] ="";
    $definition['Params'] ="";
    $definition['Label'] ="";
    $definition['Comment']="";
    $definition['Command']="";
    
    if (substr($line,0,1) =="*"){
      
      //SYNTAX (BNF, Terminals in Single Quotes(') )
      //
      // paramdefinition ::= '*' Name ['#' Command ] ':' Type Space ['(' Parameter ')']
	  //                     ['"' Label '"']['//' Comment] ;;
      // Type ::= '-'|'readonly'|'text'|'oneof'|'someof'
      // Space ::= ' ';; the only realy needed Space in this definition.
      // Name: the name of the field (exactly the same as in the 
	  //       templates parameter eg. {{{Name}}} )
      // Parameter: some text, syntax depending on the type
      
      $name = trim(substr($line,1,strpos($line,":")-1));
      if (($n=strpos($name,'#'))>0) {
		$definition['Command']=substr($name,$n+1);
		$name = trim(substr($name,0,$n));
	  }
      $definition['Name'] = $name;

      $line= trim(substr($line,strpos($line,":")+1));
      
      $positionOfBracket=strpos($line,"(")+0;
      $positionOfSpace= 0+ strPos($line," ");
	  $endofToken=strlen($line);
      if (($positionOfBracket+$positionOfSpace)==0){
		$definition['Type'] = $line;
		$line =0;
      }else{
		if (($positionOfBracket * $positionOfSpace)==0)
		  $endofToken=max($positionOfBracket, $positionOfSpace);
		else
		  $endofToken=min($positionOfBracket, $positionOfSpace);
		
		$definition['Type'] = substr($line,0,$endofToken);
      }
      $line =trim(substr($line,$endofToken));
      $positionOfBracket = strpos($line,"(");
      if ("x".$positionOfBracket != "x"){
		
		if ( "x".strpos($line,'"') != "x" ) {
		  if ( strpos($line,'"') < $positionOfBracket ) {
			$positionOfBracket=false;
		  }
		}
      }
      
      if ("x".$positionOfBracket != "x"){
		$i = $positionOfBracket+1;
		$brackets = 1;
		if ( ($i == strlen($line)) 
			 && ($brackets > 0) 
			 && ($lineNo+1 < count($lines))){
		  $lineNo++;
		  $line .= "\n".trim($lines[$lineNo]);
	}
		while ( ($i < strlen($line)) && ($brackets > 0) ) {
		  switch ($line[$i]) {
		  case '(':
			$brackets++;
			break;
		  case ')':
			$brackets--;
		  }
		  $i++;
		  
		  if ( ($i == strlen($line)) 
			   && ($brackets > 0) 
			   && ($lineNo+1 < count($lines))){
			$lineNo++;
			$line .= "\n".trim($lines[$lineNo]);
		  }
		  
		}
		$J=$i - $positionOfBracket;
		$definition['Params'] = substr($line,$positionOfBracket,$J);
		$line=substr($line,$i);
      }
      if ( "x".strpos($line,'"') != "x" ){
		$leftQuote=strpos($line,'"');
		$rightQuote=strpos($line,'"',$leftQuote+1);
		$J=$rightQuote-$leftQuote-1;
		$definition['Label']=substr($line,$leftQuote+1,$J);
      }   
      
      $definition['Comment'] = trim(substr($line,strpos($line.'//','//')+2));
      
    }
    return $definition;
  }

  /* */
}
//*///
?>