<?php 
/**
 * Author: Andreas Möller
 *
 * License: GNU GPL
 *
 * Description: I read CustomEdit and extended it by
 *    Parameter Type Definition
 *    Different input field types like checkboxes dropdownlists 
 *       and multiline inputfields.
 *  I removed from it the ability to show the form editor for an empty
 *           especially new article by removing the need of a special page.
 * for more details see www.mediawiki.org
 */

if( !defined( 'MEDIAWIKI' ) ) {
  echo( "This MediaWiki extension cannot be run standalone.\n\n"
		."Die MediaWikierweiterung ist eigenständig nicht ausführbar." );
  die( -1 );
} else {
  global $wgAutoloadClasses;
  
  // initialization of the Extension
  $dir = dirname( __FILE__ ) . '/';
  
  $wgAutoloadClasses['clsTemplateEditorHooks'] =  $dir . 'TemplateForm.hooks.php';
  $wgAutoloadClasses['clsTypeDefinition']      =  $dir . 'clsTypeDefinition.php';
  $wgAutoloadClasses['clsTemplateForm']        =  $dir . 'TemplateForm.Editor.php';
  
  // Register parser hook
  $wgHooks['ParserFirstCallInit'][] = 'clsTemplateEditorHooks::register';
  $wgHooks['AlternateEdit'][] = 'clsTemplateForm::eventhandler';

}




